import { TypedEmitter } from "tiny-typed-emitter";
import { ConstructableConnectionInterface, ConnectionInterfaceDescription, ConnectionInterface, ConnectionInterfaceEvents, ConnectionInterfaceConfiguration } from "../connectionInterface";
type InterfaceType = "gpio";
declare const InterfaceType: InterfaceType;
export interface GPIOConfiguration extends ConnectionInterfaceConfiguration {
    signals: {
        gpio: string;
    };
    driver: string;
}
export declare enum GPIOState {
    "Unknown" = 0,
    "Error" = 1,
    "StrongLow" = 2,
    "StrongHigh" = 3,
    "HighZ" = 4,
    "WeakLow" = 5,
    "WeakHigh" = 6
}
interface GPIOInterfaceData {
    driver: string;
    state: GPIOState;
}
type SignalChangeEvent = {
    state: GPIOState;
    oldState: GPIOState;
};
export interface GPIOInterfaceEvents extends ConnectionInterfaceEvents {
    signalChange(event: SignalChangeEvent): void;
}
export declare class GPIOInterface extends TypedEmitter<GPIOInterfaceEvents> implements ConnectionInterface {
    interfaceType: "gpio";
    readonly configuration: GPIOConfiguration;
    signalState: GPIOState;
    private driverStates;
    private lastDriverState;
    constructor(configuration: GPIOConfiguration);
    changeDriver(state: GPIOState): void;
    downstreamData(data: GPIOInterfaceData): void;
    private evaluateSignalState;
}
export declare class ConstructableGPIOInterface implements ConstructableConnectionInterface {
    interfaceType: InterfaceType;
    private gpios;
    constructor(gpios: string[]);
    getDescription(): ConnectionInterfaceDescription;
    create(configuration: GPIOConfiguration): GPIOInterface;
}
export {};
//# sourceMappingURL=connectionInterface.d.ts.map